port module Main exposing (..)

-- Find the generated typescript definition in... TODO

import Html exposing (Html, button, div, text)
import Html.Events exposing (onClick)


type alias Location =
    { city : String
    , state : String
    }


type alias Temperature =
    { degrees : Float
    , fahrenheit : Bool
    }


type alias Flags =
    { location : Location
    , temperature : Temperature
    }


main : Program Flags Model Msg
main =
    Html.programWithFlags
        { init = init
        , view = view
        , update = update
        , subscriptions = \_ -> reply ReplyReceived
        }


type alias Model =
    Int


init : Flags -> ( Model, Cmd Msg )
init flags =
    ( 0, hello "World" )


type Msg
    = Increment
    | Decrement
    | ReplyReceived Int


update : Msg -> Model -> ( Model, Cmd Msg )
update msg model =
    case msg of
        Increment ->
            ( model + 1, Cmd.none )

        Decrement ->
            ( model - 1, Cmd.none )

        ReplyReceived message ->
            let
                _ =
                    Debug.log "ReplyReceived" message
            in
            ( model, Cmd.none )


view : Model -> Html Msg
view model =
    div []
        [ button [ onClick Decrement ] [ text "---" ]
        , div [] [ text (toString model) ]
        , button [ onClick Increment ] [ text "+++" ]
        ]


port hello : String -> Cmd msg


port reply : (Int -> msg) -> Sub msg
